#pragma once

#include <d3d9.h>
#define SCREENWIDTH 800
#define SCREENHEIGHT 600


struct Sprite
	{
		int width;
		int height;
		D3DCOLOR key;
		D3DCOLOR* surface;
	};
struct Font
	{
		int charWidth;
		int charHeight;
		int nCharsPerRow;
		D3DCOLOR* surface;
	};

void LoadSprite(Sprite* sprite,  const char* filename,
	unsigned int width, unsigned int height, D3DCOLOR key);
void FreeSprite( Sprite* sprite);
void LoadFont(Font* font, D3DCOLOR* surface,const char* filename, int charWidth,int charHeight, int nCharsPerRow);
class D3DGraphics
{

public:
	D3DGraphics( HWND hWnd );
	~D3DGraphics();
	

	
	void PutPixel( int x,int y,int r,int g,int b );
	void PutPixel( int x,int y,D3DCOLOR c );
	void PutPixelClipped( int x,int y,int r,int g,int b );
	void DrawLine( int x1,int y1,int x2,int y2,int r,int g,int b );
	void PutPixelClipped( int x,int y,D3DCOLOR c );
	void DrawLineClipped(int x1, int y1, int x2, int y2, int r, int g, int b);
	void DrawCircle( int cx,int cy,int radius,int r,int g,int b );
	void DrawDisc( int cx,int cy,int r,int rd,int g,int b );
	void DrawBoxClipped(int x, int y, int x2, int y2, int r, int g, int blu);
	void DrawBoxUnclipped(int x, int y, int x2, int y2, int r, int g, int blu);
	void DrawSpike(int x, int y,  int r, int g, int b);
	void DrawDoorClipped(int x1, int y1);
	void DrawPlayer(int x, int y);
	void DrawGun(int x, int y);
	void DrawParticleClipped(int x, int y, int r, int g, int b);
	void DrawEnemy(int x, int y);
	void DrawBullet(int x, int y);
	void DrawMiniGame(int x, int y, int x1, int y1, int x2, int y2);
	void DrawGameOver(int x, int y);
	void DrawEnergyWave(int cx, int cy, int radius, int r, int g, int b);
	void DrawChar(char c, int x, int y, Font* font, D3DCOLOR color);
	void DrawString(const char* string, int xoff, int yoff, Font* font, D3DCOLOR color);
	void DrawSprite( int xoff, int yoff,Sprite* sprite );
	
	void BeginFrame();
	void EndFrame();
private:
	IDirect3D9*			pDirect3D;
	IDirect3DDevice9*	pDevice;
	IDirect3DSurface9*	pBackBuffer;
	D3DLOCKED_RECT		backRect;
};