#include "Game.h"
#include <stdlib.h>
#include <time.h>
#include <math.h>

Game::Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer )
:	gfx( hWnd ),
	audio( hWnd ),
	kbd( kServer ),
	mouse( mServer ),
	cameraX(0),
	cameraY(0),
	cx(WORLDWIDTH - 200 ),
	cy(400 ),
	rad(1),
	isPlayClicked(false),
	isHelpClicked(false)
	
{
	for(int index = 0; index < 5; index++)
	{
		ParticleX[index] = cx;
		ParticleY[index] = cy;
	}

	for(int index = 0; index < NENEMYS; index++)
	{
		side[index] = 0;
		enemy[ index ].isDead = false;
	}
	
	button[0].isLitUp = true;
	button[1].isLitUp = true;
	button[2].isLitUp = false;
	button[3].isLitUp = true;
	
	level.floorX = 0;
	level.floorY = 565;
	level.floorWidth = SCREENWIDTH - 1;
	level.floorHeight = SCREENHEIGHT - 1;
	level.drawLaser = true;
	
	enemyCoord();

	player.x = 90;
	player.y = 435;
	player.hp = 105;
	player.jumpHeight = 350;
	player.canShoot = true;
	player.isPlayerDead = false;
	player.OnGround = true;
	player.canJump = true;
	player.keyPressedLastFrame = false;
	

	LoadFont( &fixedSys1, fontSurf1,"Fixedsys16x28.bmp", 16, 28, 32);
	LoadFont( &fixedSys,fontSurf,"Fixedsys8x15.bmp",8,15,32);
	LoadSprite(&platformSpriteL,"Platform\\platformLEnd32x32.bmp",32,32,D3DCOLOR_XRGB(0,0,0));
	LoadSprite(&platformSpriteMid,"Platform\\platformMid32x32.bmp",32,32,D3DCOLOR_XRGB(0,0,0));
	LoadSprite(&platformSpriteR,"Platform\\platformREnd32x32.bmp",32,32,D3DCOLOR_XRGB(0,0,0));
	LoadSprite(&platformRock,"Platform\\platformRock64x64.bmp",64,64,D3DCOLOR_XRGB(255,0,0));
	LoadSprite(&backgroundSprite,"Platform\\background.bmp",800,600,D3DCOLOR_XRGB(255,255,0));
}
Game::~Game()
{
	FreeSprite(&platformSpriteL);
	FreeSprite(&platformSpriteMid);
	FreeSprite(&platformSpriteR);
	FreeSprite(&platformRock);
	FreeSprite(&backgroundSprite);
}
void Game::Go()
{
	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
	if(player.isPlayerDead == false)
	{
		if(isPlayClicked == true)
		{
			UpdateCamera();
			UpdatePlayer();
			UpdateEnemy();
			UpdateBullet();
			theJump();
			Part1();
		}
	}
}
void Game::DrawMenu()
{
	gfx.DrawLine(1,1,799,1,0,255,0); //draw border
	gfx.DrawLine(799,1,799,599,0,255,0);
	gfx.DrawLine(799,599,1,599,0,255,0);
	gfx.DrawLine(1,599,1,1,0,255,0);
	
	gfx.DrawLine(325,300,475,300,menu[0].r,menu[0].g,menu[0].b); //draw play button
	gfx.DrawLine(475,300,475,350,menu[0].r,menu[0].g,menu[0].b);
	gfx.DrawLine(475,350,325,350,menu[0].r,menu[0].g,menu[0].b);
	gfx.DrawLine(325,350,325,300,menu[0].r,menu[0].g,menu[0].b);
	
	gfx.DrawLine(325,400,475,400,menu[1].r,menu[1].g,menu[1].b); //draw help button
	gfx.DrawLine(475,400,475,450,menu[1].r,menu[1].g,menu[1].b);
	gfx.DrawLine(475,450,325,450,menu[1].r,menu[1].g,menu[1].b);
	gfx.DrawLine(325,450,325,400,menu[1].r,menu[1].g,menu[1].b);
	
	gfx.DrawString("Play",365,310,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Help",365,410,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );

	MX = mouse.GetMouseX();
	MY = mouse.GetMouseY();
	for(int index = 0; index < 2;index++)
	{
		menu[index].r  = 255; 
	}
	
		if(MX > 325 && MX < 475 && MY > 300 && MY < 350  )
		{
			menu[0].g = 0;
			menu[0].b = 0;
		}
		else
		{
			menu[0].g = 255;
			menu[0].b = 255;
		}
		
		if(MX > 325 && MX < 475 && MY > 400 && MY < 450  )
		{
			menu[1].g = 0;
			menu[1].b = 0;
		}
		else
		{
			menu[1].g = 255;
			menu[1].b = 255;
		}
		if(MX > 325 && MX < 475 && MY > 300 && MY < 350 && mouse.LeftIsPressed() )
		{
			isPlayClicked = true;	
		}

		if(MX > 325 && MX < 475 && MY > 400 && MY < 450 && mouse.LeftIsPressed() )
		{
			isHelpClicked = true;
		}
	
	
}
void Game::DrawHelpMenu()
{
	if(mouse.GetMouseX() > 325 
		&& mouse.GetMouseX() < 475 
		&& mouse.GetMouseY() > 500 
		&& mouse.GetMouseY() < 550)
	{
		g = 0;
		b = 0;
	}
	else
	{
		g = 255;
		b = 255;
	}
	
	if(mouse.GetMouseX() > 325 
		&& mouse.GetMouseX() < 475 
		&& mouse.GetMouseY() > 500 
		&& mouse.GetMouseY() < 550 
		&& mouse.LeftIsPressed())
	{
		isHelpClicked = false;
	}

	gfx.DrawLine(325,500,475,500,255,g,b);
	gfx.DrawLine(475,500,475,550,255,g,b);
	gfx.DrawLine(475,550,325,550,255,g,b);
	gfx.DrawLine(325,550,325,500,255,g,b);
	
	
	gfx.DrawString("Left Arrow - Moves left",0,0,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Right Arrow - Moves right",0,28,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Up Arrow - Jumps",0,56,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Space - Shoots",0,84,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("The mouse is used for some mini-games!",0,140,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("So if you find yourself stuck, try clicking around",0,168,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Object: ",0,224,&fixedSys1,D3DCOLOR_XRGB(255,0,0) );
	gfx.DrawString("The object of the game is to successfully ",0,252,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("navigate the level without dying.",0,280,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Coming Soon:",0,336,&fixedSys1,D3DCOLOR_XRGB(255,0,0) );
	gfx.DrawString("More weapons, weapon upgrades, and more levels!",0,364,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
	gfx.DrawString("Exit",365,510,&fixedSys1,D3DCOLOR_XRGB(0,255,0) );
}
void Game::level1()
{
	Part1GFX();
}
void Game::Part1()
{
	if(button[0].isLitUp == true 
		&& button[1].isLitUp == true 
		&& button[2].isLitUp == true 
		&& button[3].isLitUp == true)
	{
		level.drawLaser = false;
	}
	
	
	if(!player.keyPressedLastFrame) //for the mini game
	{
		if(mouse.GetMouseX() > button[0].x - cameraX 
			&& mouse.GetMouseX() < button[0].width - cameraX 
			&& mouse.GetMouseY() > button[0].y 
			&& mouse.GetMouseY() < button[0].height 
			&& mouse.LeftIsPressed() )
		{
			player.keyPressedLastFrame = true;
		
			if(button[0].isLitUp == true)
			{
				button[0].isLitUp = false;
			}
			
			else if(button[0].isLitUp == false)
			{
				button[0].isLitUp = true;
			}
			
			if(button[1].isLitUp == true)
			{
				button[1].isLitUp = false;
			}
			
			else if(button[1].isLitUp == false)
			{
				button[1].isLitUp = true;
			}
		}
		
		else if(mouse.GetMouseX() > button[1].x - cameraX 
			&& mouse.GetMouseX() < button[1].width - cameraX 
			&& mouse.GetMouseY() > button[1].y 
			&& mouse.GetMouseY() < button[1].height 
			&& mouse.LeftIsPressed() )
		{
			player.keyPressedLastFrame = true;
		
			if(button[1].isLitUp == true)
			{
				button[1].isLitUp = false;
			}
			
			else if(button[1].isLitUp == false)
			{
				button[1].isLitUp = true;
			}
			
			if(button[2].isLitUp == true)
			{
				button[2].isLitUp = false;
			}
			
			else if(button[2].isLitUp == false)
			{
				button[2].isLitUp = true;
			}
		}
		
		else if(mouse.GetMouseX() > button[2].x - cameraX 
				&& mouse.GetMouseX() < button[2].width - cameraX 
				&& mouse.GetMouseY() > button[2].y 
				&& mouse.GetMouseY() < button[2].height 
				&& mouse.LeftIsPressed() )
		{
			player.keyPressedLastFrame = true;
			
			if(button[3].isLitUp == true)
			{
				button[3].isLitUp = false;
			}
			
			else if(button[3].isLitUp == false)
			{
				button[3].isLitUp = true;
			}
			
			if(button[2].isLitUp == true)
			{
				button[2].isLitUp = false;
			}
			
			else if(button[2].isLitUp == false)
			{
				button[2].isLitUp = true;
			}
		}
		
		else if(mouse.GetMouseX() > button[3].x - cameraX 
				&& mouse.GetMouseX() < button[3].width - cameraX 
				&& mouse.GetMouseY() > button[3].y 
				&& mouse.GetMouseY() < button[3].height 
				&& mouse.LeftIsPressed() )
		{
			player.keyPressedLastFrame = true;
			
			if(button[3].isLitUp == true)
			{
				button[3].isLitUp = false;
			}
			
			else if(button[3].isLitUp == false)
			{
				button[3].isLitUp = true;
			}
			
			if(button[0].isLitUp == true)
			{
				button[0].isLitUp = false;
			}
			
			else if(button[0].isLitUp == false)
			{
				button[0].isLitUp = true;
			}
			
			if(button[2].isLitUp == true)
			{
				button[2].isLitUp = false;
			}
			
			else if(button[2].isLitUp == false)
			{
				button[2].isLitUp = true;
			}
		}
	}
	
	else if(!(mouse.LeftIsPressed()))
	{
		player.keyPressedLastFrame = false;
	}
	
	//check to see if player is colliding with laser door
	if(level.drawLaser == true)
	{
		if(player.x + 85 - cameraX >= cx - 150 - cameraX)
		{
			player.x = cx - 235;
		}
	}
	
	//if player moves into teleporter
	if(player.x - cameraX > cx - 30 - cameraX 
		&& player.x - cameraX < cx + 30 - cameraX 
		&& player.y > cy - 30 
		&& player.y < cy + 30 )
	{
		player.x = 1970;
		player.y = 76;
	}

	if(side[0] == 0)// enemy movements
	{
		if(enemy[0].x <= 425)
		{
			enemy[0].x -= 1;
			enemy[0].hp -= 1;
			if(enemy[0].x == 20)
			{
				side[0] = 1;
			}
		}
	}
	
	if(side[0] == 1)
	{
		if(enemy[0].x >= 20)
		{
			enemy[0].x += 1;
			enemy[0].hp += 1;
			if(enemy[0].x == 425)
			{
				side[0] = 0;
			}
		}
	}
	
	if(side[1] == 0)
	{
		if(enemy[1].x <= 385)
		{
			enemy[1].x -= 1;
			enemy[1].hp -= 1;
			if(enemy[1].x == 315)
			{
				side[1] = 1;
			}
		}
	}
	
	if(side[1] == 1)
	{
		if(enemy[1].x >= 315)
		{
			enemy[1].x += 1;
			enemy[1].hp += 1;
			if(enemy[1].x == 385)
			{
				side[1] = 0;
			}
		}
	}
	
	if(side[2] == 0)
	{
		if(enemy[2].x >= 1240)
		{
			enemy[2].x += 1;
			enemy[2].hp += 1;
			if(enemy[2].x == 2100)
			{
				side[2] = 1;
			}
		}
	}
	
	if(side[2] == 1)
	{
		if(enemy[2].x <= 2100)
		{
			enemy[2].x -= 1;
			enemy[2].hp -= 1;
			if(enemy[2].x == 1240)
			{
				side[2] = 0;
			}
		}
	}

	if(side[3] == 0)
	{
		if(enemy[3].x <= 2550)
		{
			enemy[3].x -= 1;
			enemy[3].hp -= 1;
			if(enemy[3].x == 2385)
			{
				side[3] = 1;
			}
		}
	}
	
	if(side[3] == 1)
	{
		if(enemy[3].x >= 2385)
		{
			enemy[3].x += 1;
			enemy[3].hp += 1;
			if(enemy[3].x == 2550)
			{
				side[3] = 0;
			}
		}
	}

	if(side[4] == 0)
	{
		if(enemy[4].x <= 2555)
		{
			enemy[4].x -= 1;
			enemy[4].hp -= 1;
			if(enemy[4].x == 2385)
			{
				side[4] = 1;
			}
		}
	}
	
	if(side[4] == 1)
	{
		if(enemy[4].x >= 2385)
		{
			enemy[4].x += 1;
			enemy[4].hp += 1;
			if(enemy[4].x == 2550)
			{
				side[4] = 0;
			}
		}
	}
}
void Game::Part1GFX()
{
	boxCoord(); //coords. for level platforms and level death hole
	
	drawBackground(cameraX,cameraY); //draw background on bottom layer so the player is clearly visible
	
	DrawTeleporter();

	int xx = WORLDWIDTH - 80;
	int yy = 62;
	
	gfx.DrawDoorClipped(3920 - cameraX,62 - cameraY);//draw exit door

	gfx.DrawSprite(295 - cameraX,410,&platformSpriteL); //same as platform[0]
		gfx.DrawSprite(327- cameraX,410,&platformSpriteMid);
		gfx.DrawSprite(359- cameraX,410,&platformSpriteMid);
		gfx.DrawSprite(391- cameraX,410,&platformSpriteR);

		gfx.DrawSprite(520- cameraX,275,&platformSpriteL); //same as platform[1]
		gfx.DrawSprite(552- cameraX,275,&platformSpriteMid);
		gfx.DrawSprite(584- cameraX,275,&platformSpriteMid);
		gfx.DrawSprite(616- cameraX,275,&platformSpriteR);

		gfx.DrawSprite(795 - cameraX, 425,&platformSpriteL); //same as platform[2]
		gfx.DrawSprite(827 - cameraX,425,&platformSpriteR);
		
		for(int x = 1020; x <= 1180; x = x + 32)
		{
			gfx.DrawSprite(x - cameraX,290,&platformSpriteMid); //same as platform[3]
		}
		
		for(int y = 322;y <= 578; y = y + 64)
		{
			for(int x = 1020; x <=   1148; x = x + 64)
			{
				gfx.DrawSprite(x - cameraX,y,&platformRock);
			}
		}
		
		
		gfx.DrawSprite(1065 - cameraX,161,&platformSpriteL); //same as platform[4]
		gfx.DrawSprite(1097 - cameraX,161,&platformSpriteMid);
		gfx.DrawSprite(1129 - cameraX,161,&platformSpriteR);

		gfx.DrawSprite(1265 - cameraX,415,&platformSpriteL); //same as platform[5]
		gfx.DrawSprite(1297 - cameraX,415,&platformSpriteMid);
		gfx.DrawSprite(1329 - cameraX,415,&platformSpriteR);

		gfx.DrawSprite(1965 - cameraX,161,&platformSpriteL); //same as platform[6]
		for(int x = 1997;x < WORLDWIDTH; x = x + 32)
		{
			gfx.DrawSprite(x - cameraX,161,&platformSpriteMid);
		}

		for(int x = 2120; x <= 2216; x = x + 32)
		{
			gfx.DrawSprite(x - cameraX,500,&platformSpriteMid);//same as platform[7]
		}
		for(int y = 532; y <= 596; y = y + 64 )
		{
			for(int x = 2120; x <= 2184; x = x + 64)
			{
				gfx.DrawSprite(x - cameraX, y, &platformRock);
			}
		}
		for(int x = 2248; x <= 2344; x = x + 32)
		{
			gfx.DrawSprite(x - cameraX,375,&platformSpriteMid);//same as platform[8]
		}
		//gfx.DrawSprite(2248 - cameraX,407,&platformRock);
		for(int y = 407; y <= 599; y = y + 64 )
		{
			for(int x = 2248; x <=2344; x = x + 64)
			{
				gfx.DrawSprite(x - cameraX, y,&platformRock);
			}
		}
		//gfx.DrawSprite(2372 - cameraX,300,&platformSpriteMid);
		for(int x = 2375; x <= 2567; x = x + 32)
		{
			gfx.DrawSprite(x - cameraX,300,&platformSpriteMid);//same as platform[9]
		}
		gfx.DrawSprite(2599 - cameraX,300,&platformSpriteMid);
		for(int y = 332; y <= 599; y = y + 64)
		{
			for(int x = 2375; x <= 2567; x = x + 64)
			{
				gfx.DrawSprite(x - cameraX,y,&platformRock);
			}
		}
	
	for(int index = 0; index < NBUTTONS; index++)
	{
		gfx.DrawMiniGame(button[ index ].lightX - cameraX,
						 button[ index ].lightY - cameraY,
						 button[ index ].x - cameraX, 
						 button[ index ].y - cameraY, 
						 button[ index ].width - cameraX, 
						 button[ index ].height - cameraY);
		
		if(button[ index ].isLitUp == true)
		{
			gfx.DrawDisc(button[ index ].lightX - cameraX, button[ index ].lightY - cameraY,15,255,255,0);
		}
	}
	
	int lx = cx - 150 - cameraX;
	
	if(level.drawLaser == true)
	{
		gfx.DrawLineClipped(lx,190,lx,550,255,0,0);
	}

}
void Game::boxCoord()
{
	
platform[0].x =  295;
	platform[1].x =  520;
	platform[2].x =  795;
	platform[3].x =  1020;
	platform[4].x =  1065;
	platform[5].x =  1265;
	platform[6].x =  1965;
	platform[7].x =  2120;
	platform[8].x =  2248;
	platform[9].x =  2375;
		
	platform[0].width =   423;
	platform[1].width =   648;
	platform[2].width =   859; 
	platform[3].width =  1212;
	platform[4].width =  1161;
	platform[5].width =  1361;
	platform[6].width =  WORLDWIDTH;
	platform[7].width =  2248;
	platform[8].width =  2376;
	platform[9].width =  2631;
	
	platform[0].y =  410;
	platform[1].y =  274; 
	platform[2].y =  424; 
	platform[3].y =  290; 
	platform[4].y =  161;
	platform[5].y =  415; 
	platform[6].y =  161;
	platform[7].y =  500;
	platform[8].y =  375;
	platform[9].y =  300; 
	
	platform[0].height =  442;
	platform[1].height =  307; 
	platform[2].height =  457; 
	platform[3].height =  578; 
	platform[4].height =  193; 
	platform[5].height =  447; 
	platform[6].height =  193; 
	platform[7].height =  599;
	platform[8].height =  599;
	platform[9].height =  599;

	button[0].lightX = WORLDWIDTH - 650;
	button[1].lightX = WORLDWIDTH - 600;
	button[2].lightX = WORLDWIDTH - 550;
	button[3].lightX = WORLDWIDTH - 500;

	button[0].lightY = 300;
	button[1].lightY = 300;
	button[2].lightY = 300;
	button[3].lightY = 300;

	button[0].x = button[0].lightX - 5;
	button[1].x = button[1].lightX - 5;
	button[2].x = button[2].lightX - 5;
	button[3].x = button[3].lightX - 5;

	button[0].y = 350;
	button[1].y = 350;
	button[2].y = 350;
	button[3].y = 350;

	button[0].width = button[0].lightX + 5;
	button[1].width = button[1].lightX + 5;
	button[2].width = button[2].lightX + 5;
	button[3].width = button[3].lightX + 5;

	button[0].height = 380;
	button[1].height = 380;
	button[2].height = 380;
	button[3].height = 380;

}
void Game::enemyCoord()
{
	enemy[0].x =  425;
	enemy[1].x =  385;
	enemy[2].x = 1240;
	enemy[3].x = 2515;
	enemy[4].x = 2550;

	enemy[0].y = 485;
	enemy[1].y = 345;
	enemy[2].y = 485;
	enemy[3].y = 235;
	enemy[4].y = 235;

	enemy[0].hp = enemy[0].x + 15;
	enemy[1].hp = enemy[1].x + 15;
	enemy[2].hp = enemy[2].x + 15;
	enemy[3].hp = enemy[3].x + 15;
	enemy[4].hp = enemy[4].x + 15;
}
void Game::drawBackground(int cameraX, int cameraY)
{
	if( cameraY == 0 )
	{
		gfx.DrawLine( 0,0,SCREENWIDTH-1,0,255,0,0 );
	}
	
	if( cameraX == 0 )
	{
		gfx.DrawLine( 0,0,0,SCREENHEIGHT-1,255,0,0 );
	}
	
	if( cameraY == WORLDHEIGHT - SCREENHEIGHT )
	{
		gfx.DrawLine( 0,SCREENHEIGHT-1,SCREENWIDTH-1,SCREENHEIGHT-1,255,0,0 );
	}
	
	if( cameraX == WORLDWIDTH - SCREENWIDTH )
	{
		gfx.DrawLine( SCREENWIDTH-1,0,SCREENWIDTH-1,SCREENHEIGHT-1,255,0,0 );
	}
	
	
	
	gfx.DrawSpike(1,1,128,128,128);
}
void Game::UpdateCamera()
{
	int facesx = player.x - cameraX;
	int facesy = player.y - cameraY;
	
	// scroll camera if face is out of tracking rectangle
	if( facesx < CTRKOFFHOR )
	{
		cameraX = player.x - CTRKOFFHOR;
	}
	
	if( facesx + 24 > SCREENWIDTH - CTRKOFFHOR )
	{
		cameraX = player.x + 24 + CTRKOFFHOR - SCREENWIDTH;
	}
	
	if( facesy < CTRKOFFVERT )
	{
		cameraY = player.y - CTRKOFFVERT;
	}
	
	if( facesy + 24 > SCREENHEIGHT - CTRKOFFVERT )
	{
		cameraY = player.y + 24 + CTRKOFFVERT - SCREENHEIGHT;
	}

	// clamp camera so that the screen does not exceed the edge of the world
	if( cameraX < 0 )
	{
		cameraX = 0;
	}
	
	else if( cameraX + SCREENWIDTH > WORLDWIDTH )
	{
		cameraX = WORLDWIDTH - SCREENWIDTH;
	}
	
	if( cameraY < 0 )
	{
		cameraY = 0;
	}
	
	else if( cameraY + SCREENHEIGHT > WORLDHEIGHT )
	{
		cameraY = WORLDHEIGHT - SCREENHEIGHT;
	}
}
void Game::UpdatePlayer()
{
	int speed = 5;
	
	if(player.isPlayerDead == false)
	{
		if(!player.keyPressedLastFrame && player.canJump == true)
		{
			if(kbd.UpIsPressed() )
			{
				player.keyPressedLastFrame = true;	
				player.OnGround = false;
			}
		}
	
		else if(!(kbd.UpIsPressed() || mouse.LeftIsPressed()))
		{
			player.keyPressedLastFrame = false;
		}	
	
		if( kbd.LeftIsPressed() ) 
		{
			player.x = player.x - speed;  
		}
	
		if( kbd.RightIsPressed() ) 
		{
			player.x = player.x + speed;	
		}

		if( player.x - 85 < 0 ) //clamp player to left side
		{
			player.x = 85;
		}

		if( player.x + 90 > WORLDWIDTH ) //clamp player to right side
		{
			player.x = WORLDWIDTH - 90;
		}
	
		if( player.y < 15 ) //clamp player to top 
		{
			player.y = 15;
		}

		if( player.y + 20 > WORLDHEIGHT )// clamp player to bottom
		{
			player.y = WORLDHEIGHT - 20;
		}
	
		//check to see if player is on level platform
		for(int index = 0; index < NPLATFORMS; index++)
		{
			if( player.y + 56 > platform[ index ].y 
				&& player.x - cameraX > platform[ index ].x - cameraX 
				&& player.x - cameraX < platform[ index ].width - cameraX)
			{
				player.OnPlatform = true;
				
			}
			
			else
			{
				player.OnPlatform = false;
			}
		}
		
		//check to see if player is colliding with level blocks 
		for(int index = 0; index < NPLATFORMS; index++) 
		{
			if(player.x - cameraX > platform[ index ].x - cameraX 
				&& player.x - cameraX < platform[ index ].width - cameraX  //this if statment checks for player under-side collision
				&& player.y - 10 > platform[ index ].y
				&& player.y - 10 < platform[ index ].height )
			{
				player.y = platform[ index ].height + 10;
			}
	
			if(player.x + 10 - cameraX > platform[ index ].x - cameraX 
				&& player.x - cameraX < platform[ index ].width - cameraX  //this if statment checks for player left-side collision 
				&& player.y - 10 > platform[ index ].y - 65 
				&& player.y - 10 < platform[ index ].height)
			{
				player.x = platform[ index ].x - 10;
			}

			if(player.x + 10 - cameraX > platform[ index ].x - cameraX
				&& player.x  - cameraX < platform[ index ].width - cameraX //this if statement checks for player top-side collision
				&& player.y + 58 > platform[ index ].y
				&& player.y < platform[ index ].height)
			{
				player.y = platform[ index ].y - 58;
				player.jumpHeight = platform[ index ].y - 200;
				player.OnPlatform = true;
			}

			if(player.x - cameraX > platform[ index ].x - cameraX
				&& player.x - 10 - cameraX < platform[ index ].width - cameraX //this if statment checks for player right-side collision
				&& player.y - 10 > platform[ index ].y - 65
				&& player.y - 10 < platform[ index ].height)
			{
				player.x = platform[ index ].width + 10;
			}
		}
	
		//floor collision NEEDS TO GO TO UPDATE PLAYER
		if(player.y + 56 > level.floorY )
			
		{
			player.y = level.floorY - 56;
			player.jumpHeight = 350;
			player.canJump = true;
		}
	
		else if(player.OnPlatform == true)
		{
			player.canJump = true;
		}
	
		else
		{
			player.canJump = false;
		}
	}
	//need code for side of hole collision. When touched, player player.jumps to top of floor
	int xx = WORLDWIDTH - 80;
	int yy = 62;
	if(player.hp <= 0)
	{
		player.isPlayerDead = true;
	}
	
	else if(player.x + 20 - cameraX > xx - cameraX && player.y - cameraY > yy - cameraY && player.y - cameraY < yy + 100 - cameraY)
	{
		player.isPlayerDead = true;
	}
	else if(player.y - cameraY < 20)
	{
		player.isPlayerDead = true;
	}
	
}
void Game::UpdateEnemy()
{
	for(int index = 0; index < NENEMYS; index++)
	{
		
		int ex = enemy[index].x - cameraX;
		//if bullet hits enemy bring down enemys health by 15
		if(player.bulletX + 85 > ex - 2 
			&& player.bulletX + 85 < ex + 5
			&& player.bulletY > enemy[ index ].y 
			&& player.bulletY < enemy[ index ].y + 65 
			&& player.canShoot == false)
		{
			enemy[ index ].hp-=15;
			player.canShoot = true;
		}
		
		
	//if enemy hits player, player loses 25 hp and the enemy dies
		if(player.bulletX  > ex - 5 
			&& player.bulletX  < ex + 5 
			&& player.y - cameraY > enemy[ index ].y - 64 
			&& player.y - cameraY < enemy[ index ].y + 65 )
		{
			if(enemy[ index ].isDead == false && player.canShoot == true)
			{
				player.hp = player.hp - 25;
			}
			enemy[ index ].isDead = true;
		}
		
		//if all enemy health runs out the enemy dies
		if(enemy[ index ].hp <= enemy[ index ].x - 15)
		{
			enemy[ index ].isDead = true;
		}
	}
}
void Game::UpdateBullet()
{	
	if(kbd.SpaceIsPressed()) //set spacebar to shoot
		{
			player.canShoot = false;
		}
		
		if(player.canShoot == true) //if the spacebar has not been pressed, bullet-x coords are set
		{
			player.bulletX  = player.x  - cameraX;
			player.bulletY = player.y ; 
		}
		
		if(player.canShoot == false && player.bulletX < (player.x + 199) - cameraX) //if bullet has been fired and
		{																	 //if bullet is less than 199 pixels away from player(max shoot distance)
			player.bulletX = player.bulletX + 8;										 //increase the bullet's x postion by 8 pixels a frame
		}
		
		if(player.bulletX > (player.x + 199) - cameraX) //if the bullet has reached max shoot distance, stop drawing, and give user to shoot again
		{
			player.canShoot = true;
		}
	}
void Game::DrawTeleporter()
{
	for(int index = 0; index < 5; index++)
	{
		gfx.DrawParticleClipped(ParticleX[index] - cameraX, ParticleY[index] - cameraY,255,255,255);
	}
	
	gfx.DrawDisc(cx - cameraX,cy - cameraY,30,0,0,255);
	
	if(rad < 30)
	{
		gfx.DrawDisc(cx - cameraX,cy - cameraY,rad,255,255,255);
		rad++;
	}
	
	if(rad == 30)
	{
		rad = 0;
	}
	
	if(rad > 15)
	{
		gfx.DrawDisc(cx - cameraX,cy - cameraY,rad - 10,0,0,255);
	}
	
	if(ParticleX[0] < cx + 100)
	{
		ParticleX[0] += 8;
		ParticleY[0] -= 8;
		
		if(ParticleX[0] > cx + 100)
		{
			ParticleX[0] = cx;
			ParticleY[0] = cy;
		}
	}
	
	if(ParticleX[1] > cx - 100 )
	{
		ParticleX[1] -= 8;
		ParticleY[1] -= 8;
		
		if(ParticleX[1] < cx - 100)
		{
			ParticleX[1] = cx;
			ParticleY[1] = cy;
		}
	}
	
	if(ParticleX[2] > cx - 100)
	{
		ParticleX[2] -= 8;
		ParticleY[2] += 8;
		
		if(ParticleX[2] < cx - 100)
		{
			ParticleX[2] = cx;
			ParticleY[2] = cy;
		}
	}

	if(ParticleX[3] < cx + 100)
	{
		ParticleX[3] += 8;
		ParticleY[3] += 8;
		
		if(ParticleX[3] > cx + 100)
		{
			ParticleX[3] = cx;
			ParticleY[3] = cy;
		}
	}
}
void Game::theJump()
{
	if(player.OnGround == false)
			{
				//player.canJump = false;
				player.jump = 4;
				player.y -= player.jump; 
				
				if(player.jump > -4)
				{
					player.jump -= 0.1f;
				}
				
				for(int index = 0;index < NPLATFORMS;index++)
				{
					if(player.y - 10 <= platform[ index ].height 
						&& player.x > platform[ index ].x 
						&& player.x < platform[ index ].width 
						&& player.y > platform[ index ].y
						|| player.y < 15)
					{
						player.TouchingBottom = true;
					}
				}
				if(player.OnGround==true)
				{
					player.jump = 0;
				}
				if(player.y - cameraY < player.jumpHeight || player.TouchingBottom == true)
				{
					player.OnGround = true;
					player.TouchingBottom = false;
				}
				
			}
		
	if(player.OnGround == true)
	{
		player.y += 3 - cameraY;
	}
}
void Game::ComposeFrame()
{
	gfx.DrawSprite(0,0,&backgroundSprite);
	if(isPlayClicked == false && isHelpClicked == false)
	{
		DrawMenu();
	}
	if(isHelpClicked == true)
	{
		DrawHelpMenu();
	}
	
	if(isPlayClicked == true)
	{
		level1();
		
			gfx.DrawPlayer(player.x - cameraX  ,player.y );
			gfx.DrawString("Health",5,30,&fixedSys,D3DCOLOR_XRGB(0,255,0) );
			gfx.DrawBoxUnclipped(5,50,player.hp,60,0,255,0);
			//if player is able to shoot and bullet hasnt reach max distance, draw the bullet
			if(player.canShoot == false && player.bulletX < (player.x + 150) - cameraX)
			{
				gfx.DrawBullet(player.bulletX ,player.bulletY );	
			}
		
		for(int index = 0; index < NENEMYS; index++)
			{
				if(enemy[index].isDead == false)
				{
					gfx.DrawEnemy(enemy[index].x - cameraX,enemy[index].y - cameraY);
					gfx.DrawBoxClipped(enemy[index].x - cameraX - 15, enemy[index].y - 10 - cameraY, enemy[ index ].hp - cameraX, enemy[index].y - 5 - cameraY,255,255,0);
				}
			}
		if(player.isPlayerDead == true)
		{
			gfx.DrawGameOver(375,300);
		}
	}
	
	for(int p = 0; p < 4000; p = p + 32)
	{
		gfx.DrawSprite(p,568,&platformSpriteMid);
	}
	
}
